// Copyright (C) 2006 Pushok Software http://www.pushok.com/soft_svncom.php
//
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// Subversion is Copyrght of(c) 2000-2004 CollabNet.  All rights reserved.
// Full license available here http://subversion.tigris.org/license-1.html.

#include "stdafx.h"
#include "SVNWcEntry.h"


// CSVNWcEntry

STDMETHODIMP CSVNWcEntry::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_ISVNWcEntry
	};

	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}



STDMETHODIMP CSVNWcEntry::put_Name(BSTR sVal)
{
	LOCK_THIS_OBJ
	name = sVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_Name(BSTR* psVal)
{
	LOCK_THIS_OBJ
	return name.CopyTo(psVal);
}


STDMETHODIMP CSVNWcEntry::put_Revision(LONG lVal)
{
	LOCK_THIS_OBJ
	revision = lVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_Revision(LONG* plVal)
{
	if (!plVal)
		return E_INVALIDARG;
	LOCK_THIS_OBJ
	*plVal = revision;
	return S_OK;
}


STDMETHODIMP CSVNWcEntry::put_Url(BSTR sVal)
{
	LOCK_THIS_OBJ
	url = sVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_Url(BSTR* psVal)
{
	LOCK_THIS_OBJ
	return url.CopyTo(psVal);
}


STDMETHODIMP CSVNWcEntry::put_Repos(BSTR sVal)
{
	LOCK_THIS_OBJ
	repos = sVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_Repos(BSTR* psVal)
{
	LOCK_THIS_OBJ
	return repos.CopyTo(psVal);
}


STDMETHODIMP CSVNWcEntry::put_Uuid(BSTR sVal)
{
	LOCK_THIS_OBJ
	uuid = sVal;
	return S_OK;
}

STDMETHODIMP CSVNWcEntry::get_Uuid(BSTR* psVal)
{
	LOCK_THIS_OBJ
	return uuid.CopyTo(psVal);
}


STDMETHODIMP CSVNWcEntry::put_Kind(SvnNodeKind Val)
{
	LOCK_THIS_OBJ
	kind = Val;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_Kind(SvnNodeKind* pVal)
{
	if (!pVal)
		return E_INVALIDARG;
	LOCK_THIS_OBJ
	*pVal = kind;
	return S_OK;
}


STDMETHODIMP CSVNWcEntry::put_Schedule(SvnWcSchedule Val)
{
	LOCK_THIS_OBJ
	schedule = Val;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_Schedule(SvnWcSchedule* pVal)
{
	if (!pVal)
		return E_INVALIDARG;
	LOCK_THIS_OBJ
	*pVal = schedule;
	return S_OK;
}


STDMETHODIMP CSVNWcEntry::put_Copied(BOOL blVal)
{
	LOCK_THIS_OBJ
	copied = blVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_Copied(BOOL* pblVal)
{
	if (!pblVal)
		return E_INVALIDARG;
	LOCK_THIS_OBJ
	*pblVal = copied;
	return S_OK;
}


STDMETHODIMP CSVNWcEntry::put_Deleted(BOOL blVal)
{
	LOCK_THIS_OBJ
	deleted = blVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_Deleted(BOOL* pblVal)
{
	if (!pblVal)
		return E_INVALIDARG;
	LOCK_THIS_OBJ
	*pblVal = deleted;
	return S_OK;
}


STDMETHODIMP CSVNWcEntry::put_Absent(BOOL blVal)
{
	LOCK_THIS_OBJ
	absent = blVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_Absent(BOOL* pblVal)
{
	if (!pblVal)
		return E_INVALIDARG;
	LOCK_THIS_OBJ
	*pblVal = absent;
	return S_OK;
}


STDMETHODIMP CSVNWcEntry::put_Incomplete(BOOL blVal)
{
	LOCK_THIS_OBJ
	incomplete = blVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_Incomplete(BOOL* pblVal)
{
	if (!pblVal)
		return E_INVALIDARG;
	LOCK_THIS_OBJ
	*pblVal = incomplete;
	return S_OK;
}



STDMETHODIMP CSVNWcEntry::put_CopyFromUrl(BSTR sVal)
{
	LOCK_THIS_OBJ
	copyfrom_url = sVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_CopyFromUrl(BSTR* psVal)
{
	LOCK_THIS_OBJ
	return copyfrom_url.CopyTo(psVal);
}


STDMETHODIMP CSVNWcEntry::put_CopyFromRev(LONG lVal)
{
	LOCK_THIS_OBJ
	copyfrom_rev = lVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_CopyFromRev(LONG* plVal)
{
	if (!plVal)
		return E_INVALIDARG;
	LOCK_THIS_OBJ
	*plVal = copyfrom_rev;
	return S_OK;
}


STDMETHODIMP CSVNWcEntry::put_ConflictOld(BSTR sVal)
{
	LOCK_THIS_OBJ
	conflict_old = sVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_ConflictOld(BSTR* psVal)
{
	LOCK_THIS_OBJ
	return conflict_old.CopyTo(psVal);
}


STDMETHODIMP CSVNWcEntry::put_ConflictNew(BSTR sVal)
{
	LOCK_THIS_OBJ
	conflict_new = sVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_ConflictNew(BSTR* psVal)
{
	LOCK_THIS_OBJ
	return conflict_new.CopyTo(psVal);
}


STDMETHODIMP CSVNWcEntry::put_ConflictWrk(BSTR sVal)
{
	LOCK_THIS_OBJ
	conflict_wrk = sVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_ConflictWrk(BSTR* psVal)
{
	LOCK_THIS_OBJ
	return conflict_wrk.CopyTo(psVal);
}


STDMETHODIMP CSVNWcEntry::put_Prejfile(BSTR sVal)
{
	LOCK_THIS_OBJ
	prejfile = sVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_Prejfile(BSTR* psVal)
{
	LOCK_THIS_OBJ
	return prejfile.CopyTo(psVal);
}


STDMETHODIMP CSVNWcEntry::put_TextTime(CY cyVal)
{
	LOCK_THIS_OBJ
	text_time = cyVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_TextTime(CY* pcyVal)
{
	if (!pcyVal)
		return E_INVALIDARG;
	LOCK_THIS_OBJ
	*pcyVal = text_time;
	return S_OK;
}


STDMETHODIMP CSVNWcEntry::put_PropTime(CY cyVal)
{
	LOCK_THIS_OBJ
	prop_time = cyVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_PropTime(CY* pcyVal)
{
	if (!pcyVal)
		return E_INVALIDARG;
	LOCK_THIS_OBJ
	*pcyVal = prop_time;
	return S_OK;
}


STDMETHODIMP CSVNWcEntry::put_Checksum(BSTR sVal)
{
	LOCK_THIS_OBJ
	checksum = sVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_Checksum(BSTR* psVal)
{
	LOCK_THIS_OBJ
	return checksum.CopyTo(psVal);
}


STDMETHODIMP CSVNWcEntry::put_CmtRev(LONG lVal)
{
	LOCK_THIS_OBJ
	cmt_rev = lVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_CmtRev(LONG* plVal)
{
	if (!plVal)
		return E_INVALIDARG;
	LOCK_THIS_OBJ
	*plVal = cmt_rev;
	return S_OK;
}


STDMETHODIMP CSVNWcEntry::put_CmtDate(CY cyVal)
{
	LOCK_THIS_OBJ
	cmt_date = cyVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_CmtDate(CY* pcyVal)
{
	if (!pcyVal)
		return E_INVALIDARG;
	LOCK_THIS_OBJ
	*pcyVal = cmt_date;
	return S_OK;
}


STDMETHODIMP CSVNWcEntry::put_CmtAuthor(BSTR sVal)
{
	LOCK_THIS_OBJ
	cmt_author = sVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_CmtAuthor(BSTR* psVal)
{
	LOCK_THIS_OBJ
	return cmt_author.CopyTo(psVal);
}


STDMETHODIMP CSVNWcEntry::put_LockToken(BSTR sVal)
{
	LOCK_THIS_OBJ
	lock_token = sVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_LockToken(BSTR* psVal)
{
	LOCK_THIS_OBJ
	return lock_token.CopyTo(psVal);
}


STDMETHODIMP CSVNWcEntry::put_LockOwner(BSTR sVal)
{
	LOCK_THIS_OBJ
	lock_owner = sVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_LockOwner(BSTR* psVal)
{
	LOCK_THIS_OBJ
	return lock_owner.CopyTo(psVal);
}


STDMETHODIMP CSVNWcEntry::put_LockComment(BSTR sVal)
{
	LOCK_THIS_OBJ
	lock_comment = sVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_LockComment(BSTR* psVal)
{
	LOCK_THIS_OBJ
	return lock_comment.CopyTo(psVal);
}


STDMETHODIMP CSVNWcEntry::put_LockCreationDate(CY cyVal)
{
	LOCK_THIS_OBJ
	lock_creation_date = cyVal;
	return S_OK;
}
STDMETHODIMP CSVNWcEntry::get_LockCreationDate(CY* pcyVal)
{
	if (!pcyVal)
		return E_INVALIDARG;
	LOCK_THIS_OBJ
	*pcyVal = lock_creation_date;
	return S_OK;
}
