// Copyright (C) 2006 Pushok Software http://www.pushok.com/soft_svncom.php
//
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// Subversion is Copyrght of(c) 2000-2004 CollabNet.  All rights reserved.
// Full license available here http://subversion.tigris.org/license-1.html.

#pragma once
#include "resource.h"       // main symbols

#include "pcom.h"


// CSVNWcStatus

class ATL_NO_VTABLE CSVNWcStatus : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CSVNWcStatus, &CLSID_SVNWcStatus>,
	public ISupportErrorInfo,
	public IDispatchImpl<ISVNWcStatus2, &IID_ISVNWcStatus2, &LIBID_PushOkSvn, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
	CSVNWcStatus()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SVNWCSTATUS)

BEGIN_COM_MAP(CSVNWcStatus)
	COM_INTERFACE_ENTRY(ISVNWcStatus)
	COM_INTERFACE_ENTRY(ISVNWcStatus2)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

	DECLARE_PROTECT_FINAL_CONSTRUCT()
	DECLARE_GET_CONTROLLING_UNKNOWN()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}
	
	void FinalRelease() 
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

private:
	//svn_wc_status2_t
  CComPtr<ISVNWcEntry> entry;
  SvnWcStatusKind text_status;
  SvnWcStatusKind prop_status;
  BOOL locked;
  BOOL copied;
  BOOL switched;
  SvnWcStatusKind repos_text_status;
  SvnWcStatusKind repos_prop_status;
  CComPtr<ISVNLock> repos_lock;
  // since 1.3
  CComBSTR url;
  LONG last_cmt_rev;
  CY last_cmt_date;
  SvnNodeKind kind;
  CComBSTR last_cmt_author;

public:
	STDMETHOD(put_Entry)(ISVNWcEntry* pVal);
	STDMETHOD(get_Entry)(ISVNWcEntry** ppVal);
	STDMETHOD(put_TextStatus)(SvnWcStatusKind Val);
	STDMETHOD(get_TextStatus)(SvnWcStatusKind* pVal);
	STDMETHOD(put_PropStatus)(SvnWcStatusKind Val);
	STDMETHOD(get_PropStatus)(SvnWcStatusKind* pVal);
	STDMETHOD(put_Locked)(BOOL blVal);
	STDMETHOD(get_Locked)(BOOL* pblVal);
	STDMETHOD(put_Copied)(BOOL blVal);
	STDMETHOD(get_Copied)(BOOL* pblVal);
	STDMETHOD(put_Switched)(BOOL blVal);
	STDMETHOD(get_Switched)(BOOL* pblVal);
	STDMETHOD(put_ReposTextStatus)(SvnWcStatusKind Val);
	STDMETHOD(get_ReposTextStatus)(SvnWcStatusKind* pVal);
	STDMETHOD(put_ReposPropStatus)(SvnWcStatusKind Val);
	STDMETHOD(get_ReposPropStatus)(SvnWcStatusKind* pVal);
	STDMETHOD(put_ReposLock)(ISVNLock* pVal);
	STDMETHOD(get_ReposLock)(ISVNLock** ppVal);
	STDMETHOD(get_URL)(BSTR* pVal);
	STDMETHOD(put_URL)(BSTR newVal);
	STDMETHOD(get_LastCmtRev)(LONG* pVal);
	STDMETHOD(put_LastCmtRev)(LONG newVal);
	STDMETHOD(get_LastCmtDate)(CY* pVal);
	STDMETHOD(put_LastCmtDate)(CY newVal);
	STDMETHOD(get_LastCmtKind)(SvnNodeKind* pVal);
	STDMETHOD(put_LastCmtKind)(SvnNodeKind newVal);
	STDMETHOD(get_LastCmdAuthor)(BSTR* pVal);
	STDMETHOD(put_LastCmdAuthor)(BSTR newVal);
};

OBJECT_ENTRY_AUTO(__uuidof(SVNWcStatus), CSVNWcStatus)

#include <map>

namespace PushokAtlEx
{
	template <>
	class GenericCopy<VARIANT,PushokAtlEx::CComPtrAdapt< ISVNWcStatus> >
	{
	public:
		static void init(VARIANT* p) {
			CComVariant vt; vt.Detach(p);
		}
		static HRESULT copy(VARIANT* pTo, const PushokAtlEx::CComPtrAdapt< ISVNWcStatus> * pFrom) {
			CComVariant vt((IDispatch *)*pFrom);
			return vt.Detach(pTo);
		}
		static void destroy(VARIANT* p) {
			CComVariant vt; vt.Attach(p);
		}
	};
	template <>
	class GenericCopy<ISVNWcStatus *,PushokAtlEx::CComPtrAdapt< ISVNWcStatus> >
	{
	public:
		static void init(ISVNWcStatus ** p) {
		}
		static HRESULT copy(ISVNWcStatus ** pTo, const PushokAtlEx::CComPtrAdapt< ISVNWcStatus> *pFrom) {
			return const_cast< PushokAtlEx::CComPtrAdapt< ISVNWcStatus> *>(pFrom)->CopyTo(pTo);
		}
		static void destroy(ISVNWcStatus ** p) {
			if (*p) (*p)->Release();
		}
	};
}

namespace SVNWcStatusCollection_
{
	// Store our data in a vector of std::strings
	typedef std::map< CComBSTR, PushokAtlEx::CComPtrAdapt< ISVNWcStatus> >	ContainerType;

	// Now we have all the information we need to fill in the template arguments on the implementation classes
	typedef CComEnumOnSTL< IEnumVARIANT, &__uuidof(IEnumVARIANT), VARIANT,
		PushokAtlEx::MapCopy<ContainerType,VARIANT>, ContainerType > EnumeratorType;

	typedef PushokAtlEx::ICollectionOnSTLCopyImpl< ISVNWcStatusCollection, ContainerType, ISVNWcStatus *,
							PushokAtlEx::MapCopy<ContainerType,ISVNWcStatus *>, EnumeratorType > CollectionType;

};

class ATL_NO_VTABLE CSVNWcStatusCollection : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CSVNWcStatusCollection, &CLSID_SVNWcStatusCollection>,
	public IDispatchImpl<SVNWcStatusCollection_::CollectionType,&__uuidof(ISVNWcStatusCollection)>
{
public:
	CSVNWcStatusCollection()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SVNWCSTATUSCOLLECTION)

BEGIN_COM_MAP(CSVNWcStatusCollection)
	COM_INTERFACE_ENTRY(ISVNWcStatusCollection)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()


	DECLARE_PROTECT_FINAL_CONSTRUCT()
	DECLARE_GET_CONTROLLING_UNKNOWN()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}
	
	void FinalRelease() 
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

public:
	STDMETHOD(get_Item)(BSTR Index, ISVNWcStatus** pVal)	{
		LOCK_THIS_OBJ
		SVNWcStatusCollection_::ContainerType::iterator pIt;
		pIt = m_coll.find(CComBSTR(Index));
		return pIt!=m_coll.end()?(*pIt).second.CopyTo(pVal):E_INVALIDARG;
	}
	STDMETHOD(Add)(BSTR pKey, ISVNWcStatus* pVal) {
		LOCK_THIS_OBJ
		m_coll[pKey] = PushokAtlEx::CComPtrAdapt<ISVNWcStatus>(pVal);
		return S_OK;
	}
	STDMETHOD(Remove) (BSTR pKey) {
		LOCK_THIS_OBJ
		m_coll.erase(pKey);
		return S_OK;
	}
};

OBJECT_ENTRY_AUTO(__uuidof(SVNWcStatusCollection), CSVNWcStatusCollection)

